{$N+}
unit func2;
interface
type
        float = Extended;

function reciprocal(x : float) : float;
function power(x : float; n : LongInt) : float;

implementation
const
        eps = 1.0e-10;
function reciprocal(x : float) : float;
var
        a, b : float;
begin
        a := 1.0;  b := 1.0 - x;
        repeat
                a := a * (1.0 + b);
                b := Sqr(b);
        until  b < eps;
        reciprocal := a;
end;
function power(x : float;  n : LongInt) : float;
var
        m : LongInt;
        y, z : float;
begin
        if  n = 0  then  power := 1.0
        else
        begin
                m := Abs(n);
                y := 1.0;
                z := x;
                while  m > 0  do
                begin
                        if  Odd(m)  then
                        begin
                                y := y * z;
                        Dec(m);
                        end
                        else
                        begin
                                z := Sqr(z);
                                m := m shr 1;
                        end;
                end;
                if  n >= 0  then  power := y
                        else
                        begin
                                if  y = 0.0  then  Halt
                                        else  power := 1.0 / y;
                        end;
                end;
end;
begin
end.
