program fern;
uses
        Graph, graphs, Crt;
var
        ch : Char;
procedure draw;
const
        iterations = 50000;
var
        t, x, y, p : Real;
        k : LongInt;
        mid_x, mid_y, radius : Integer;
begin
        mid_x := GetMaxX div 2;
        mid_y := GetMaxY;
        radius := Trunc(0.1 * mid_y);
        Randomize;
        x := 1.0;
        y := 0.0;
        for  k := 1  to  iterations  do
        begin
                p := Random;
                t := x;
                if  p <= 0.85  then
                begin
                        x := 0.85 * x - 0.04 * y;
                        y := -0.04 * t + 0.85 * y + 1.6;
                end
                else
                        if  p <= 0.92  then
                        begin
                                x := 0.20 * x - 0.26 * y;
                                y := 0.23 * t + 0.22 * y + 1.6;
                        end
                        else
                                if  p <= 0.99  then
                                begin
                                        x := -0.15 * x + 0.28 * y;
                                        y := 0.26 * t + 0.24 * y + 0.44;
                                end
                                else
                                begin
                                        x := 0.0;
                                        y := 0.16 * y;
                                end;
                PutPixel(mid_x + Round(radius * x), 
                        mid_y - Round(radius * y), LightGreen);
        end;
end;
begin
        open_graph;
        draw;
        OutTextXY(0, 465, 'Press <Space>:');
        ch := ReadKey;
        close_graph;
end.
