unit shapes;
interface
uses
        Graph, Crt;
type
        shape = object
                color : Byte;
                procedure draw; virtual;
        end;
        shapeptr = ^shape;
        box = object(shape)
                lowerrightx, lowerrighty : Integer;
                upperleftx, upperlefty : Integer;
                constructor create(ulx, uly, lrx, lry, c : Integer);
                procedure draw; virtual;
        end;
        circ = object(shape)
                xcenter, ycenter : Integer;
                radius : Integer;
                constructor create(x, y, rad, c : Integer);
                procedure draw; virtual;
        end;
implementation
procedure shape.draw;
begin
end;
constructor box.create(ulx, uly, lrx, lry, c : Integer);
begin
        upperleftx  := ulx;
        upperlefty  := uly;
        lowerrightx := lrx;
        lowerrighty := lry;
        color       := c;
end;
procedure box.draw;
begin
        SetColor(color);
        Rectangle(upperleftx, upperlefty, lowerrightx, lowerrighty);
end;
constructor circ.create(x, y, rad, c : Integer);
begin
        xcenter := x;
        ycenter := y;
        radius  := rad;
        color   := c;
end;
procedure circ.draw;
begin
        SetColor(color);
        Circle(xcenter, ycenter, radius);
end;
end.
