program Turtle_Driver;
uses
        Graph, graphs, Crt;
const
        TurtleSpeed = 100;
var
        Magnitude, Color, G_MaxX, G_MaxY, G_MaxColor : Integer;
        PenColor : Byte;
        TDelay, Heading, Pos_X, Pos_Y, WinLoX, WinLoY, WinHiX,
        WinHiY, WinOrgX, WinOrgY : Integer;
procedure ShowTurtleDelay;
begin
        PutPixel(Pos_X, Pos_Y, 3);
        if  TDelay >0  then  Delay(TDelay)
end;
procedure Home;
begin
        Pos_X := 0;
        Pos_Y := 0;
        MoveTo(WinOrgX, WinOrgY);
        Heading := 0;
end;
procedure ResetTurtle;
begin
        SetColor(G_MaxColor);
        TDelay := 0;
        Home;
end;
procedure Init_Turtle;
begin
        G_MaxColor := GetMaxColor;
        G_MaxX := GetMaxX;
        G_MaxY := GetMaxY;
        WinOrgX := G_MaxX div 2;
        WinOrgY := G_MaxY div 2;
        WinLoX := - WinOrgX;
        WinLoY := - WinOrgY;
        WinHiX :=  WinOrgX;
        WinHiY :=  WinOrgY;
        ResetTurtle;
end;
procedure Forwd(Dist : Integer);
var
        NewX, NewY, NewXs, NewYs : Integer;
begin
        NewX := Pos_X + (Trunc(Dist * Cos((90 - Heading) * Pi / 180)));
        NewY := Pos_Y + (Trunc(Dist * Sin((90 - Heading) * Pi / 180)));
        NewXs := WinOrgX + NewX;
        NewYs := WinOrgY - NewY;
        LineTo(NewXs, NewYs);
        Pos_X := NewX;
        Pos_Y := NewY;
        ShowTurtleDelay;
end;
procedure Move_Turtle;
var
        InKey : Char;
        FunctionKey : Boolean;
procedure NewScreen;
begin
        ClearViewPort;
        OutTextXY(25, GetMaxY - 30, 'Speed : 0-9  (C)olor.' +
                'Turn : F1, F2, Home : +, (E)rase');
        ShowTurtleDelay;
        home;
        Magnitude := 0;
end;
function GetKey(var FunctionKey : Boolean) : Char;
var
        ch : Char;
begin
        Ch := ReadKey;
        if  (Ch = #0) and KeyPressed  then
        begin
                Ch := ReadKey;
                FunctionKey := True;
        end
        else
                FunctionKey := False;
        GetKey := Ch;
end;
procedure TurtleDo(InKey : Char; FunctionKey : Boolean);
        procedure DoFunctionCommand(FunctionKey : Char);
        begin
                case  FunctionKey  of
                '<' : Heading := (Heading + 5) mod 360;
                ';' : Heading := (Heading - 5) mod 360;
                end
        end;
begin
        if  FunctionKey  then
                DoFunctionCommand(UpCase(InKey))
        else
                case  UpCase(InKey)  of
                '+' : Home;
                'C' : begin
                                Color := Succ(color) mod (GetMaxColor + 1);
                                SetColor(Color);
                        end;
                'E' : NewScreen;
                '0'..'9' : Magnitude := Sqr(Ord(inkey) - Ord('0'));
                end;
end;
begin
        NewScreen;
        repeat
                TDelay := TurtleSpeed;
                repeat
                        if  Magnitude <> 0  then  forwd(Magnitude);
                until  KeyPressed;
                Inkey := GetKey(FunctionKey);
                TurtleDo(InKey, FunctionKey);
        until  UpCase(Inkey) in [#27, ^C];
end;
begin
        open_graph;
        Init_Turtle;
        Magnitude := 0;
        Color := 0;
        Move_Turtle;
        close_graph;
end.
