program tetrahedron;
uses
        Graph, Crt, graphs3d;
var
        x, z, y, xstep, ystep, theta : Real;
        i, j, xold, yold, xnew, ynew : Integer;
        P : projection;
procedure draw_tetra;
var
        xp, yp : array[1..4] of Integer;
begin
        project(P, 0, 0, 0, 0, 0, xp[1], yp[1]);
        project(P, 0, 0, 50, 0, 0, xp[2], yp[2]);
        project(P, 0, 50, 0, 0, 0, xp[3], yp[3]);
        project(P, 50, 0, 0, 0, 0, xp[4], yp[4]);
        norm_line(xp[1], yp[1], xp[2], yp[2], White);
        norm_line(xp[1], yp[1], xp[3], yp[3], White);
        norm_line(xp[1], yp[1], xp[4], yp[4], White);
        norm_line(xp[3], yp[3], xp[4], yp[4], White);
        norm_line(xp[2], yp[2], xp[3], yp[3], White);
        norm_line(xp[2], yp[2], xp[4], yp[4], White);
end;
begin
        abs_x_center := 0; abs_y_center := 0;
        open_graph;
        compute_isometric_matrix(P);
        ClearViewPort;
        out_text_XY('Isometric Projection', -150, 150, Yellow);
        draw_tetra;
        ReadLn;
        theta := 45;
        compute_oblique_matrix(theta, P);
        ClearViewPort;
        out_text_XY('Oblique Projection', -150, 150, Yellow);
        draw_tetra;
        ReadLn;
        theta := 45;
        repeat
                compute_oblique_matrix(theta, P);
                ClearViewPort;
                draw_tetra;
                theta := theta + 1;
        until  KeyPressed;
        ReadLn;
        theta := 15;
        compute_dimetric_matrix(theta, P);
        ClearViewPort;
        out_text_XY('Dimetric Projection', -150, 150, Yellow);
        draw_tetra;
        ReadLn;
        theta := 15;
        repeat
                compute_dimetric_matrix(theta, P);
                ClearViewPort;
                draw_tetra;
                theta := theta + 1;
        until  theta >= 45;
        ReadLn;
        close_graph;
end.
