program surf1;
uses
        Crt, Graph, graphs, graphs3d;
const
        nx = 25;
        ny = 25;
        a = -200;
        b = 200;
        c = -200;
        d = 200;
var
        i, j, tt : Byte;
        x, y, z, ux, uy, t, theta, xmin, xmax, ymin, ymax : Real;
        xx, yy : array[1..nx, 1..ny] of Integer;
        P : projection;
function f(x, y : Real) : Real;
begin
        f := 20 * Sin(t * Sqrt(x * x + y * y));
end;
procedure anim(tt : Byte);
begin
        ux := Abs(b - a) / (nx - 1);
        uy := Abs(d - c) / (ny - 1);
        x := a; y := c; z := f(x, y);
        project(P, x, y, z, 0, 0, xx[1, 1], yy[1, 1]);
        xx[1, 1] := xx[1,1] + GetMaxX div 2;
        yy[1, 1] := GetMaxY div 2 - yy[1, 1];
        xmin := xx[1, 1]; xmax := xmin;
        ymin := yy[1, 1]; ymax := ymin;
        for  i := 1  to  nx  do
        begin
                y := c;
                for  j := 1  to  ny  do
                begin
                        z := f(x, y);
                        project(P, x, y, z, 0, 0, xx[i, j], yy[i, j]);
                        xx[i,j] := xx[i, j] + GetMaxX div 2;
                        yy[i,j] := GetMaxY div 2 - yy[i, j];
                        if  xmin > xx[i, j]  then  xmin := xx[i, j]
                                else if  xmax < xx[i, j]  then  xmax := xx[i, j];
                        if  ymin > yy[i, j]  then  ymin := yy[i, j]
                                else if  ymax < yy[i, j]  then  ymax := yy[i, j];
                        y := y + uy;
                end;
                x := x + ux;
        end;
        SetColor(tt);
        for  i := 1  to  nx  do
        begin
                MoveTo(xx[i, 1], yy[i, 1]);
                for  j := 2  to  ny  do LineTo(xx[i, j], yy[i, j]);
        end;
        for  j := 1  to  ny  do
        begin
                MoveTo(xx[1, j], yy[1, j]);
                for  i := 1  to  nx  do  LineTo(xx[i, j], yy[i, j]);
        end;
end;
begin
        open_graph;
        t := 0;
        theta := 20;
        repeat
                compute_dimetric_matrix(theta, P);
                anim(12);
                anim(0);
                t := t + 0.001;
        until  KeyPressed;
        close_graph;
end.
